unit LinkListADT;

Interface
  uses EntryObjADT;   { ꥪ⮢ ⨯ Entry}

type
 ListPointer = ^ListNode;
 ListNode = record
              Info :  Entry:       {ଠ樮 }
              Link : ListPointer  {㪠⥫ 
                                         ᫥騩 㧥}
            end . {ListNode}

 Link.List=object
             constructor Init;
             procedure ReadList;
             procedure Insert (AnEntry : Entry;
                               var Success : Boolean);
             procedure Search (AnEntry : Entry;
                               var Success : Boolean);
             procedure Replace (AnEntry : Entry:
                               var Success : Boolean);
             procedure Delete (AnEntry : Entry;
                               var Success : Boolean);
             procedure Retrieve (var AnEntry : Entry;
                                 var Success : Boolean);
             function GetCount : Integer;
             procedure DisplayList;
             destructor Done;

           private
             Head : ListPointer;  {㪠⥫  
                                                  㧥}
             Count : Integer;     {᫮ 㧫}
             procedure DoSearch (First : ListPointer;
                                 AnEntry : Entry;
                                 var Success : Boolean);

             procedure DoReplace (var First:ListPointer;
                                  AnEntry : Entry;
                                  var Success:Boolean);
             procedure DoDelete (var First:ListPointer;
                                 AnEntry : Entry;
                                 var Success : Boolean);
           end; {LinkList}

Implementation

  constructor LinkList.Init;
  {
    ⮩ ᯨ᮪.
   ।᫮ ; 
   ᫮ :  ⮩ ᯨ᮪ ( ᮤঠ騩
                   ).
  }
  begin {Init}
    Count := 0;
    Head := nil
  end; {Init}

  procedure LinkList.ReadList;
  {
   뢠  ᯨ᮪   묨.
   ।᫮ ;   묨 ।⠢ ᮡ
                 ⥪⮢ 䠩.
   ᫮ :   䠩  묨
                 ७ᥭ  ᯨ᮪.
  }
    var
      AnEntry : Entry;     { }
      InFile : Text:       {७ 䠩
                                         ६}
      FileName : string;   {譥  室 䠩}
      Success : Boolean:   {䫠}

  begin {ReadList}
    WriteLn ('  䠩  묨> ');
    ReadLn ( FileName);
    Assign (InFile, FileName);
    Reset (InFile):             {⨥ 䠩.}

    {뢠    ᥭ   ᯨ᮪.}
    while not EOF(InFile) do
      begin
        AnEntry.ReadEntry (InFile, FileName); {뢠
                                                }
        Insert (AnEntry, Success)      {⠢ 
                                               ᯨ᮪}
      end {while};

    Close (InFile)
  end; {ReadList}

  procedure LinkList.Insert (AnEntry : Entry;
                             var Success : Boolean);
  {
   ⠢  AnEntry  ᯨ᮪.
   ।᫮ :  AnEntry ।.
   ᫮ : ⠢ AnEntry   
                 ᯨ᪠  ⠭ Success  True.
  }
    var
      OldHead : ListPointer;   {㪠⥫  
                                       ᯨ᪠}

  begin {Insert}
    OldHead : Head;          {࠭ 㪠⥫ 
                                     ६ OldHed}
    New (Head);              {७ࠢ
                               㪠⥫   㧥}
    Head^.Info := AnEntry ;  {ᥭ  
                                㧥 ()}
    Head^.Link := OldHead;   {뢠 
                                     }
    Count := Count + 1;      {祭  㧫}
    Success := True
  end; {Insert}

  procedure LinkList.DoSearch (First {室} : ListPointer;
                               AnEntry {室} : Entry;
                           var Success {室} : Boolean);
  {
   믮 ४ᨢ .
   ।᫮ : ⥫ First 뫠  
                 ᯨ᪠,  ஬ ந .
   ᫮ : ᫨ 祢 , ᮢ饥 
                 AnEntry 㦥, Success ᢠ
                 祭 True;  ⨢ 砥 Success
                 ᢠ 祭 False.
  }

  begin {DoSearch}
    if First = nil then
      Success := False
    else if AnEntry.EqualTo(First^.Info) then
      Success := True
    else
      DoSearch (First^.Link, AnEntry, Success)
  end; {DoSearch}

  procedure LinkList.Search (AnEntry {室} : Entry;
                           var Success {室} : Boolean);

  {
   뢠 楤 DoSearch  ᪠  ᯨ᪥
     祢 , ᮢ騬  AnEntry.
   ।᫮ : 祭 AnEntry ।,
   ᫮ : ᫨ 祢 , ᮢ饥 
                 AnEntry 㦥, Success ᢠ
                 祭 True;  ⨢ 砥 Success
                 ᢠ 祭 False.
  }
  begin   {Search}
    DoSearch (Head, AnEntry, Success)
  end; {Search}

  procedure   LinkList.DoReplace (var First {室/室} :
                                             ListPointer;
                                  AnEntry {室} : Entry;
                           var Success {室} : Boolean;
  {
   믮 ४ᨢ .
   ।᫮ : ⥫ First 뫠  
                 ᯨ᪠,  ஬ ந .
   ᫮ : ᫨ 祢 , ᮢ饥 
               AnEntry, 㦥,   
               Success ᢠ 祭 True;
                ⨢ 砥 Success
               ᢠ 祭 False.
  }

  begin {DoReplace}
    if First = nil then
      Success   := False
    else if AnEntry.EqualTo(First^.Info) then
      begin   {found  key}
        First^.Info := AnEntry;     { .}
        Success := True
      end   {found  key}
    else
      DoReplace (First^.Link, AnEntry, Success)
  end; {DoReplace}

  procedure LinkList.Replace (AnEntry {室} : Entry;
                          var Success {室} : Boolean);
  {
   ⠢ AnEntry    ᮢ騬
   祢 .
   ।᫮ : 祭 AnEntry ।.
   ᫮ :   祢    AnEntry
                   Success ᢮ 祭
                 True;  ⨢ 砥 Success
                 ᢮ 祭 False.
  }
  begin {Replace}
    DoReplace (Head, AnEntry, Success)
  end;   {Replace}


  procedure LinkList.DoDelete (var First {室/室} :
                                              ListPointer;
                               AnEntry {室} : Entry;
                            var Success {室} : Boolean;
  {
   믮 ४ᨢ 㤠.
   ।᫮ : ⥫ First 뫠  
                 ᯨ᪠,  ஬ ந .
   ᫮ : ᫨ 祢 , ᮢ饥 
                 AnEntry, 㦥,  㤠 
                 Success ᢠ 祭 True;
                  ⨢ 砥 Success
                 ᢠ 祭 False.
  }

    var
      ToDelete : ListPointer; {⥫  㧥,
                            ।祭  㤠.}

  begin {DoDelete}
    if First = nil then
      Success := False
    else if AnEntry.EqualTo(First^.Info) then
      begin {found key}
        ToDelete := First;    {  ᯨ᪠.}
        First := First^.Link; {"室" ண .}
        ToDelete^.Link := nil; {⪫祭 ண
                                               .}
        Dispose (ToDelete);    {饭 ᢮襩
                                             .}
        Success := True
      end {found key}
    else
      DoDelete (First^.Link, AnEntry, Success)
  end; {DoDelete}

  procedure LinkList.Delete (AnEntry : Entry;
                             var Success : Boolean);
  {
      祢    AnEntry.
   ।᫮ : 祭 AnEntry ।.
   ᫮ : ᫨ 祢 , ᮢ饥 
                 AnEntry, 㦥,  㤠 
                 Success ᢠ 祭 True;
                  ⨢ 砥 Success
                 ᢠ 祭 False.
  }
  begin {Delete}
    DoDelete (Head, AnEntry, Success);
    if Success then
    Count := Count - 1 {襭 Count ᫥ 㤠.}
  end: {Delete}

  destructor  LinkList.Done;
  {
   頥    , 
   ⠬ ᯨ᪠.
   ।᫢ : ⥫ Head 뫠  ᯨ᮪.
   ᫮ : Count  祭 0   ,
                 ᯮ쫧 ᯨ᪮, ᢮.
  }
    var OldHead : ListPointer; {⥫  
                                   ᯨ᪠.}

  begin {Done}
    while Head <> nil do
      {ਠ :    । 祭
       Head  뫮 ࠢ nil.}
      begin
        OldHead := Head;         {࠭ 㪠⥫
                                    .}
        Head := Head^.Link; {६饭 Head  ᯨ.}
        OldHead^.Link := nil;    {ᮥ ண
                                            .}
        Dispose (OldHead)        {᢮ .}
      end;  {while}

    Count := 0                    {᮪ .}
  end:  {Done}

{ ᫥ ⠢ ⮤ Retrieve,
 GetCount, DisplayList.}

end. {LinkListADT}
