unit ListADT;

interface
  uses EntryObjADT;      { ⨯ Entry}

const
  MaxEntry = 100;               {ᨬ 㭪⮢}

type
  EntryRange = 1..MaxEntry;       { 㭪⮢}
  EntryArray = array [EntryRange] of Entry;

  List = object
           procedure Init;
           procedure ReadList;
           procedure Insert (AnEntry : Entry;
                             var Success : Boolean);
           procedure Replace (AnEntry : Entry;
                              var Success : Boolean);
           procedure Delete (AnEntry : Entry;
                             var Success : Boolean);
           procedure Search (AnEntry : Entry;
                             var PosEntry : Integer;
                             var Success : Boolean);
           procedure GetEntry (var AnEntry : Entry;
                               var Success : Boolean);
           function GetCount : Integer;
           procedure Sort;
           procedure DisplayList;

         private
           Entries : EntryArray;   {ᨢ 㭪⮢}
           Count : Integer;        {᫮ 㭪⮢}
         end; {List}

implementation

  procedure List.Init;
  {
    ⮩ ᯨ᮪.
   ।᫮ : 
   ᫮ : । ꥪ List,
                 ᮤঠ騩 0 ⮢.
  }
  begin {Init}
    Count := 0
  end; {Init}

  procedure List.ReadList;
  {
   뢠   䠩  ᯨ᮪.
   ।᫮ : ⢥騩 䠩 
                 묨   ᪥.
   ᫮ : 㭪  䠩  묨
                 ᥭ  ᯨ᮪.
  }
    var
      Next : Integer;       { ᫥饣 㭪}
      AnEntry : Entry;                   { 㭪}
      InFile : Text;             {䠩 ६}
      FileName : string;  {譥  室 䠩}

  begin {ReadList}
    Write ('  䠩 > ');
    ReadLn (FileName);
    Assign (InFile, FileName);
    Reset (InFile);           {⨥ 䠩 .}

    Next := 0;
    while not EOF(InFile) and (Next < MaxEntry) do
      begin
        AnEntry.ReadEntry (InFile, FileName);   {뢠 㭪.}
        Next := Next + 1;
        Entries[Next] := AnEntry     {ᥭ ᫥饣 㭪  ᯨ᮪.}
      end; {while}

    Count := Next;     {Count ᮮ⢥  㭪⮢.}
    if not EOF(InFile) then
      WriteLn ('  ⨣  䠩 !');
    Close (InFile)
  end; {ReadList}

  procedure List.Insert (AnEntry {室} : Entry;
                         var Success {室} : Boolean);
  {
     ᯨ᮪ 㭪 AnEntry.
   ।᫮ : AnEntry ।.
   ᫮ : ᫨ ᯨ᮪  , AnEntry
                 ⠭ ᫥ 㭪⮬  ᯨ᪥
                  Success  祭 True;
                  Success  祭 False.
  }
  begin {Insert}
    if Count < MaxEntry then
      begin {ᥭ 㭪}
        Count := Count + 1;  { ᫥饣 㭪}
        Entries[Count] := AnEntry; {AnEntry --  ᫥ 㭪.}
        Success := True
      end {ᥭ 㭪}
    else
      Success := False
  end; {Insert}

  procedure List.Search (AnEntry {室} : Entry;
                         var PosEntry {室} : Integer;
                         var Success {室} : Boolean);
  {
     ᯨ᪥ 㭪 AnEntry.
   ।᫮ : AnEntry ।.
   ᫮ : ᫨ AnEntry , Success 
                 祭 True,  祭 PosEntry
                 ᮮ⢥    ᯨ᪥;
                  Success  祭 False.
  }
    var
      Next : Integer;     {᫥騩   ᯨ᪥}

  begin {Search}
    {   List ࠢ  AnEntry.}
    Next := 1;           {砫 --  ࢮ 㭪.}
    Success := False;          {AnEntry  .}
    while not Success and (Next <= Count) do
      {ਠ:
         AnEntry  ᨢ Entries[1..Next - 1]
            Next <= Count + 1.
      }
      if AnEntry.EqualTo(Entries[Next]) then
        Success := True           {AnEntry .}
      else
        Next := Next + 1;    { ᫥饬 㭪.}
    {⢥ভ:
       AnEntry 㦥   㭪 뫨
       ᯥ譮 ஢७.
    }
    if Success then
      PosEntry := Next        {AnEntry ᮮ⢥
                                 Entries[Next].}
  end; {Search}

  procedure List.Replace (AnEntry {室} : Entry;
                          var Success {室} : Boolean);
  {
   㭪, 祢  ண ⠪ ,  
   AnEntry,   AnEntry.
   ।᫮ : AnEntry ।.
   ᫮ : 㭪  ⠪  祢   
                 AnEntry,  ⠪  , 
                 Success  祭 True; 
                 Success  祭 False.
  }
    var
      PosEntry : Integer;  { AnEntry  ᯨ᪥.}

  begin {Replace}
    Search (AnEntry, PosEntry, Success); { AnEntry.}
    if Success then
      Entries[PosEntry] := AnEntry           {.}
  end; {Replace}

  procedure List.Delete (AnEntry {室} : Entry;
                         var Success {室} : Boolean);
  {
    㭪  祢 , ⠪ 
     AnEntry.
   ।᫮ : AnEntry ।.
   ᫮ : ᫨ AnEntry 㦥, ᫥ 㭪
                   AnEntry  Success 
                 祭 True;  Success 
                 祭 False.
  }
    var
      PosEntry : Integer;      { AnEntry  ᯨ᪥.}

  begin {Delete}
    Search (AnEntry, PosEntry, Success);  { AnEntry.}
    if Success then
      begin
        Entries[PosEntry] := Entries[Count]; {஢
                                      ᫥ 㭪.}
        Count := Count - 1        {襭 Count.}
      end {if}
  end; {Delete}

  procedure List.GetEntry (var AnEntry {室} : Entry;
                           var Success {室} : Boolean);
  {
   ⢫ 롮 㭪  祢  
    AnEntry.
   ।᫮ : AnEntry ।.
   ᫮ : AnEntry ᮤন   
                 Entries  ⠪  祢  
                 Success  祭 True; 
                 Success  祭 False.
  }
    var
      PosEntry : Integer;     { AnEntry  ᯨ᪥}
  begin {GetEntry}
    Search (AnEntry, PosEntry, Success); { AnEntry.}
    if Success then
      AnEntry := Entries[PosEntry]  {롮ઠ .}
  end; {GetEntry}

  function List.GetCount : Integer;
  {
   頥 ᫮ 㭪⮢  ᯨ᪥.
   ।᫮ : 
   ᫮ : 頥 ᫮ 㭪⮢  ᯨ᪥.
  }
  begin {GetCount}
    GetCount := Count
  end; {GetCount}

  procedure List.DisplayList;
  {
   뢮 ᮤ ᯨ᪠.
   ।᫮ : 
   ᫮ : 뢮  㭪 ᯨ᪠.
  }
    var
      AnEntry : Entry;   {᫥騩 㭪}
      Next : Integer;    { ᫥饣 㭪}
  begin {DisplayList}
    WriteLn ('᮪ 㭪⮢:');
    for Next := 1 to Count do
      begin
        Entries[Next].DisplayEntry;  {뢮 ᫥饣 㭪.}
        WriteLn
      end {for}
  end; {DisplayList}

  end. {ListADT}
