unit QueueADT;
{
 ন ᠭ ꥪ Queue  ⮤
 Init, Insert, Remove  IsEmpty.
}

Interface
  uses QueueDataADT;  {஢ ⨯ QueueData.}

  type
    0ueuePointer = ^QueueNode;
    QueueNode =  record
                   Info : OueueData;     {. }
                   Link : QueuePointer   {뫪 
                                      ᫥騩 㧥}
                 end; {0ueueNode}

Queue = object
          constructor Init;
          procedure Insert (El : QueueData);
          procedure Remove (var El : QueueData;
                            var Success : Boolean);
          function IsEmpty : Boolean;
          function GetSize : Integer;
          destructor Done;

        private
          Front,                {㪠⥫  砫 Q}
          Rear : QueuePointer;   {㪠⥫   Q}
          Size : Integer;              {ࠧ ।}
        end; {Queue}

implementation

  constructor Queue.Init;
  {
     ।.
   ।᫮ : .
   ᫮ : । 樠஢ 㫥묨
                 祭ﬨ
  }
  begin  {Init}
    Front := nil;
    Rear  := nil;
    Size  := 0
  end  {Init}

  procedure Queue.Remove (var El {室}:QueueData;
                          var Success {室}:Boolean);
  {
       砫 ।   
     ࠬ El.
    ।᫮ : । 㦥 ᮧ.
    ᫮ : ᫨ ।  , E1 ᮤন
                    . ⥫ Front
                  뫠    ,
                   Success 㪠뢠  ᯥ 
                  㤠 樨.
  }
    var
      OldFront : QueuePointer;    {६ 㪠⥫}

  begin {Remove}
    if Front = nil then
      Success := False            {। .}
    else
      begin
        {   砫 ।.}
        OldFront := Front;   {OldFront ਥ
                                         㧥.}
        El := Front^.Info;      {롮ઠ  㧫.}
        Front := Front^.Link    { ண
                                         ࢮ 㧫.}
        OldFront^.Link := nil;  {ᮥ .}
        Dispose (OldFront);     {᢮ .}
        Size := Size - 1;       {襭 ࠧ Q.}
        Success := True
      end {if}
  end; {Remove}

  procedure Queue.Insert (El {室} ; QueueData);
  {
    祭 El  ।.
   ।᫮ : । 㦥 ᮧ.
   ᫮ : 祭 El    㧥,
                   ८ਥ 㪠⥫
                 Rear. ᫨  । ⢥
                 ,   㧥 ਥ
                 ⠪ 㪠⥫ Front.
  }
  begin {Insert}
    if Rear = ni1 then
      begin { ।}
        New (Rear);            {Rear 㪠뢠 
                                           㧥.}
        Front : Rear           {Front 㪠뢠 
                                           㧥.}
      end { ।}
    else
      begin { ।}
        New (Rear^.Link);         { 頥 
                                         ।.}
        Rear := Rear^.Link        {Rear ਥ
                                          㧥.}
      end; { ।}

    Rear^.Info : El;   {ᥭ   㧥 .}
    Rear^.Link := nil:
    Size := Size + 1            {祭 ࠧ Q.}
  end; {Insert}

  function Queue.IsEmpty : Boolean;
  {
   ஢,    ।.
   ।᫮ : । 㦥 ᮧ.
   ᫮ : 頥 True ᫨ । ;
                  ⨢ 砥 頥 False.
  }
  begin {IsEmpty}
    IsEmpty := (Front := nil)
  end  {IsEmpty}

  { ᫥ ⠢ ⮤ GetSize  Done.}

end.  {QueueADT}
