const
  StringLength = 14;    {  ப, ஬ ⮢ }
  ZipStringSize = 5;    { ப  ⮢ }

type
  IDRange = 1111.9999;
  StringIndex = [1..StringLength];
  ZipIndex = [1..ZipStringSize];
  StringType = packed array [StringIndex] of Char;
  ZipString = packed array [ZipIndex] of Char;
  Month = (January, February, March, April, May, June, July,
           August, September, October, November, December);

  Employee = record
               ID : IDRange;
               Name : StringType;
               Gender : Char;
               NumDepend : Integer;
               Rate, TotWages : Real
             end; {Employee}

  Address = record
              Street, City, State : StringType;
              ZipCode : ZipString
            end; {Address}

  Date = record
           ThisMonth : Month;
           Day : 1..31;
           Year : 1900..1999
         end; {Date}

  NewEmployee = record
                  PayData : Employee
                  Home : Address;
                  StartDate, BirthDate : Date
                end; {NewEmployee}

var
  Programmer : NewEmployee;

procedure ReadNewEmp (var NewEmp {室} : NewEmployee);
{
   뢠   ६- NewEmp.
   Pre  : .
   Post : 뢠      NewEmp.
   맮: 楤 ReadEmployee (. . 11.18),
          ReadAddress, and ReadDate (. ࠦ  ணࠬ஢)
}
begin  {ReadNewEmp}
  with NewEmp do
    begin
      ReadEmployee (PayData);
      ReadAddress (Home);
      ReadDate (StartDate);
      ReadDate (BirthDate)
    end {with}
end; {ReadNewEmp}
