{$R+}
program SalesAnalysis;
{뢠   த      
 ⠡, ࣠  ࣮ ।⠢⥫
  ⠫. 뢮 ⠡   ⮣ 
  ।⠢⥫    ⠫.
}
  const
    NumberSalesPeople = 5;    {᫮ ।⠢⥫}

  type
    People = 1..NumberSalesPeople;
    Person = People;
    Quarter = (Fall, Winter, Spring, Summer);
    SalesArray = array [People, Quarter] of Real;
    RowArray = array [People] of Real;
    ColArray = array [Quarter] of Real;

  var
    SalesFile : Text;         {䠩  묨}
    Sales : SalesArray;       {㬥ୠ ⠡}
    RowSum : RowArray;        {⮣  ப}
    ColSum : ColArray;        {⮣  ⮫栬}

procedure Initialize (var Sales {室} : SalesArray;
                      InvValue {室} : Real);
{
  樠   ᢮ ࠬ-ᨢ
  祭 InValue.
  Pre  : 祭 InValue ।.
  Post :    ࠬ-ᨢ 
         祭 InValue.
}
  var
    NextPerson : People;         { ப}
    NextQuarter : Quarter;       { ⮫殢}

begin {Initialize}
  for NextPerson := 1 to NumberSalesPeople do
    for NextQuarter := Fall to Summer do
      Sales[NextPerson, NextQuarter] := InvValue
end; {Initialize}

procedure SumRows (Sales {} : SalesArray;
                   var RowSum {뢮} : RowArray);
{
 㬬 ப ᨢ Sales; 祭 㬬
   ᨢ RowSum.
 Pre  : 祭 ⮢ ᨢ Sales ।.
 Post : RowSum[I] --  㬬 ⮢  ப I.
}
  var
    NextPerson : People ;       { ப}
    NextQuarter : Quarter;      { ⮫殢}
    Sum : Real;                 {६ 㬬}

begin {SumRows}
  for NextPerson := 1 to NumberSalesPeople do
    begin
      Sum := 0.0;
      for NextQuarter := Fall to Summer do
        Sum := Sum + Sales[NextPerson, NextQuarter];
      {㬬 ᫥饩 ப}
      RowSum[NextPerson] := Sum
    end {譥 横 for}
end; {SumRows}

procedure SumColumns (Sales {} : SalesArray;
                      var ColSum {뢮} : ColArray);
{
 㬬 ⮫ ᨢ Sales; 祭 㬬
   ᨢ ColSum.
 Pre  : 祭 ⮢ ᨢ Sales ।.
 Post : ColSum[I] --  㬬 ⮢ ⮫ I.
}
  var
    NextPerson : People ;       { ப}
    NextQuarter : Quarter;      { ⮫殢}
    Sum : Real;                 {६ 㬬}

begin {SumColumns}
  for NextQuarter := Fall to Summer do
    begin
      Sum := 0.0;
      for NextPerson := 1 to NumberSalesPeople do
        Sum := Sum + Sales[NextPerson, NextQuarter];
      {㬬 ᫥饣 ⮫}
      ColSum[NextQuarter] := Sum
    end {譥 横 for}
end; {SumColumns}

procedure ReadTable (var SalesFile {} : Text;
                     var Sales {뢮} : SalesArray);
{
 뢠 室   䠩    
 ⠡ (㬥 ᨢ).
 Pre  :  १ த 樠஢ ﬨ.
 Post :   ࠬ Sales ।⠢
        ᮡ 㬬 ᤥ  ।
        ।⠢⥫   । ⠫.
 맮: ReadQuarter 祭   ⠫.
}
  var
    TranAmount : Real;            {ꥬ ᤥ}
    TranPerson : Integer;         { ।⠢⥫}
    TranQuarter : Quarter;        {⠫}
    ValidQuarter : Boolean;       {䫠, 㪠뢠騩,
                                   ४  ⠫
                                    ⠭}

begin {ReadTable}
  {⮢   뢠.}
  Assign (SalesFile, 'SALEDATA.TXT');
  Reset (SalesFile);

  {뢠 .}
  while not EOF(SalesFile) do
    begin
      Read (SalesFile, TranPerson);
      ReadQuarter (SalesFile, TranQuarter, ValidQuarter);
      ReadLn (SalesFile, TranAmount);
      if ValidQuarter and (TranPerson >= 1) and (TranPerson <= 5) then
        Sales[TranPerson, TranQuarter] := Sales[TranPerson, TranQuarter]
        + TranAmount
      else
        WriteLn ('४ ।⠢⥫  ⠫ - ',
                 '।⠢⥫ ', TranPerson :1,
                 '; ꥬ ᤥ ', TranAmount :3:2)
    end {while}
end; {ReadTable}

procedure DisplayTable (Sales {} : SalesArray;
                        RowSum {} : RowArray;
                        ColSum {} : ColArray);
{
 뢮   த   ⠡,  
 㬬  ப  ⮫栬.
 Pre  : Sales, RowSum  ColSum ।.
 Post : 뢮 祭, ᮤঠ騥   ᨢ.
}
  var
    NextPerson : Person;
    NextQuarter : Quarter;

begin
  {뢮 .}
  WriteLn;
  WriteLn (' ' :40);
  WriteLn ('[ᥭ]' :20, '[]' :10, '[᭠]' :10,
         '[]' :10, ' ।⠢⥫');

  {  ।⠢⥫ 뢮 ப ⠡.}
  for NextPerson := 1 to NumberSalesPeople do
    begin
      Write ('[' :8, NextPerson :1, ']');
      for NextQuarter := Fall to Spring do
        Write (Sales[NextPerson, NextQuarter] :10:2);
      WriteLn (RowSum[NextPerson] : 14:2)
    end; {for NextPerson}

  {뢮 㬬 ⮫殢.}
  WriteLn;
  Write (' ⠫' :10);
  for NextQuarter := Fall to Spring do
    Write (ColSum[NextQuarter] :10:2);
  WriteLn;
end; {DisplayTable}

begin {SalesAnalysis}
  Initialize (Sales, 0.0);
  ReadTable (SalesFile, Sales);
  SumRows (Sales, RowSum);
  SumColumns (Sales, ColSum);
  DisplayTable (Sales, RowSum, ColSum)
end. {SalesAnalysis}
