unit SearchTreeADT;
{
 ন ꥪ⮢ ⨯ SearchTree,  ⠪ 
 ⮤: Init, Search, Insert, Retrieve  Display.
}
Interface
  uses TreeDataADT;  { ⨯ TreeData  ⮤
                       EqualTo, LessThan, DisplayItem.}
  type
     Branch = ^TreeNode;
     TreeNode = record
                 Info : TreeData;       {ଠ樮
                                                  }
                 Left , Right : Branch  {㪠⥫}
               end; {TreeNode}

  SearchTree = object
                 constructor Init;
                 procedure Search (El : TreeData:
                                   var Success:Boolean);
                 procedure Insert (El : TreeData;
                                   var Success:Boolean);
                 procedure Retrieve (var El : TreeData;
                                   var Success:Boolean);
                 procedure Display;
                 destructor Done;

               private
                 Root : Branch;  {㪠⥫  ୥
                                                   㧥}
                 procedure DoSearch (ARoot : Branch;
                                     El : TreeData;
                                   var Success:Boolean);
                 procedure DoRetrieve (ARoot : Branch;
                                       var El:TreeData;
                                   var Success:Boolean);
                 procedure DoDisptay (ARoot : Branch;
                                      El : TreeData;
                                   var Success:Boolean);
              end; {SearchTree}

implementation
  constructor SearchTree.Init;
  {
    ⮥ ॢ.  뢠 .
   ।᫮ : .
   ᫮ : ⥫  ୥ 㧥 
                 祭 nil.
  }
  begin {Init}
    Root := nil
  end; {Init}

  procedura SearchTree.DoSearch (ARoot {室} : Branch;
                                 El {室} : TreeData;
                        Var Success {室} : Boolean);
  {
     ॢ ( ஥ 㪠뢠 ARoot)
    祭 祢 , ᮢ騬  E].
   ।᫮ : El  ARoot ।.
   ᫮ : ᫨ 祢  ࠬ El 
                 , Success ⠭ 
                 False;  Success ᢠ
                 祭 True.
  }
  begin {DoSearch}
    if ARoot = nil then
      Success := False              {ॢ ⮥.}
    else if El.EqualTo(ARoot^.Info) then
      Success := True               { ᯥ襭.}
    else if El.LessThan(ARoot^.Info) then
      DoSearch (ARoot^.Left. El, Success)   {᪠ 
                                      ॢ.}
    else
      DoSearch (ARoot^.Right, El, Success)  {᪠ 
                                    ࠢ ॢ.}
  end: {DoSearch}

  procedure SearchTree.Search (El {室} : TreeData;
                         var Success {室} : Boolean):
  {
     筮 ॢ ᪠  祭
   祢 , ᮢ騬  El.
   ।᫮ : ॢ ᮧ.
   ᫮ : ᫨ 㦭  㦥, Success
                 ⠭  True;  ⨢
                 砥 Success ᢠ 祭
                 False.
  }
  begin {Search}
    DoSearch (Root, El, Success) {砫 ᪠.}
  end; {Search}

  procedure SearchTree.DoInsert (var ARoot {室/室}:
                                                  Branch;
                            El {室} : TreeData;
                            var Success {室} Boolean);
  {
   ⠢  El  ॢ,  ஥
   㪠뢠 ARoot.
   ।᫮ : ARoot  El ।.
   ᫢ : ᫨ 㦥 㧥  祢 ,
                 ᮢ騬  El, Success ⠭
                  False. ᫨  ⢫ 
                 ⮬ ॢ, ARoot ਥ 
                  㧥, ᮤठ騩 祭 El,
                  Success ⠭  True.
  }
  begin {Dolnsert}
    {஢ઠ,  ⮥  ॢ.}
    if ARoot = nil then
      begin {祭  㧫.}
        New (ARoot);          {ਥ஢ ARoot
                                            㧥.}
        ARoot^.Left := nil;   { 㧥 ॢ頥
                                             㧥-.}
        ARoot^.Right := nil;
        ARoot^.Info := El;  {ᥭ El  㧥 ARoot^.}
        Success := True
      end {祭  㧫.}
    else if El.EqualTo(ARoot^.Info) then
      Success := False            {饥
                                      祢 祭.}
    else if El.LessThan(ARoot^.Info) then
      DoInsert (ARoot^.Left, El, Success) { 
                                             .}
    else
      DoInsert (ARoot^.Right, El, Success) { 
                                           ࠢ .}
  end {Dolnsert}

  procedure SearchTree.Insert (El {室} : TreeData;
                            var Success {室} Boolean);
  {
     El  筮 ॢ ᪠.
   ।᫮ : El  ॢ ।.
   ᫮ : ᫨ ⠢  ᯥ筮 믮,
                 Success ⠭  True. ᫨ 
                 ॢ  㧥  祢 祭,
                 ᮢ騬  El, Success ⠭
                  False.
  }
  begin {Insert}
    DoInsert (Root, El, Success)
  end; {Insert}

  procedure SearchTree.DoDisplay (ARoot {室} : Branch;
  {
   冷祭 ( 祢 祭) 뢮 
   筮 ॢ ᪠.
   ।᫮ : ARoot 㪠뢠  筮 ॢ ᪠
                   祭 nil.
   ᫮ : ⮡ࠦ  㧥 ॢ  祢
                 祭.
  }
  begin {DoDisplay}
    if ARoot <> nil then
      begin {४ᨢ 蠣}
        DoDisplay (ARoot^.Left);  {뢮  ⢨.}
        ARoot^.Info.DisplayItem;  {뢮  ॢ.}
        DoDisplay (ARoot^,Right)  {뢮 ࠢ ⢨.}
      end {४ᨢ 蠣}
  end; {DoDisplay}

  procedure SearchTree.Display;
  {
   뢮  筮 ॢ ᪠.
   ।᫮ : Root - 㪠⥫   筮
                 ॢ ᪠.
   ᫮ : 뢮   ॢ. 
                 뢮  ⠭, ᮣ᭮
                 祭 祢 .
  }
  begin (Display)
    DoDisplay (Root)
  end, {Display}

  { ᫥ ⠢ ⮤ Retrieve, DoRetrieve  Done.}

end. {SearchTreeADT}
